/**
	Haed a free program maker and generator
	Copyright (C) 2018  Florian Evaldsson

	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/
/**
	Clean it up!
*/

#include "includes.h"

static int GLOBAL_DRAG_BOX_POS[4]={-1,-1,-1,-1};
static int MOV_OBJECT[2]={-1,-1};

void SetStoryBoardMode(GtkWidget *widget,gpointer   data)
{
	printf("set to storyboard\n");
	gtk_notebook_set_current_page(GTK_NOTEBOOK(MAIN_Notebook),0);
}

void SetLevelEditorMode(GtkWidget *widget,gpointer   data)
{
	printf("set to level editor\n");
	gtk_notebook_set_current_page(GTK_NOTEBOOK(MAIN_Notebook),1);
}

void SetEventEditorMode(GtkWidget *widget,gpointer   data)
{
	printf("set to event editor\n");
	gtk_notebook_set_current_page(GTK_NOTEBOOK(MAIN_Notebook),2);
}

void UpdateEventGrid(GtkWidget *widget,gpointer data)
{
	printf("update event editor\n");
}

int CreatePopupMenu(GtkWidget *menu,GdkEvent *event)
{
	if(event->type == GDK_BUTTON_PRESS && event->button.button == GDK_BUTTON_SECONDARY)
	{
		gtk_menu_popup(GTK_MENU(menu), NULL, NULL, NULL, NULL, event->button.button, event->button.time);
		return 1;
	}
	return 0;
}
//===================EDIT ACTIVE OBJECT MENU=====================
//SELECT MOVEMENT WINDOW
void SelectMovementActiveObjectButton(GtkWidget *widget,gpointer data)
{
	EksParent *thisObj=data;
	
	int movementType;
	
	movementType=SelectMovementActiveObject();
	//printf("%d \n",movementType);
	
	//thisObj->movType=movementType;
	
	switch(movementType)
	{
		//STOPPED
		case 0:
			printf("Movement set to stopped\n");
			haed_object_set_string(thisObj,"mov","none",0);
			//objectInnerSettings->player=0;
			//free(objectInnerSettings->speed);
			//free(objectInnerSettings->acceleration);
			//free(objectInnerSettings->deacceleration);
			//objectInnerSettings->speed=NULL;
			//objectInnerSettings->acceleration=NULL;
			//objectInnerSettings->deacceleration=NULL;
			
			haed_object_set_int(thisObj,"player",0,1);
			haed_object_set_double(thisObj,"speed",0,1);
			haed_object_set_double(thisObj,"acceleration",0,1);
			haed_object_set_double(thisObj,"deacceleration",0,1);
			
		break;
		//ALL DIRECTIONS
		case 1:
			haed_object_set_string(thisObj,"mov","all_directions",0);
			haed_object_set_int(thisObj,"player",1,0);
			MovementAllDirectionsEdit(thisObj);
		break;
	}
	
	//HAED_GLOBAL_ACTION_INF=NULL;
}

void haed_object_modify_movement(GtkWidget *widget,gpointer data)
{
	EksParent *thisObj=data;

	MovementAllDirectionsEdit(thisObj);
}

void SelectPlayerActiveObjectButton(GtkWidget *widget,gpointer data)
{
	intptr_t player=(intptr_t)data;

	EksParent *thisObj=g_object_get_data(G_OBJECT(widget),"haed_object");
	
	if(thisObj==NULL)
	{
		thisObj=eks_parent_custom_get(HAED_GLOBAL_INFORMATION.levelEditorSelectedUnits,0);
	}

	//EksParent *objectInnerSettings;
	//objectInnerSettings=(EksParent*)(thisObj->objectTypeStruct);
	
	//objectInnerSettings->player=(int)(long)data;
	haed_object_set_int(thisObj,"player",player,0);
	
	printf("Player set to: %ld\n",player);

	//HAED_GLOBAL_ACTION_INF=NULL;
}

//REMOVE OBJECT FROM LEVEL EDITOR
void haed_level_editor_active_object_remove_from_draw_area(GtkWidget *widget,gpointer data)
{
	EksParent *obj=data;
	
	b_tm("remove obj: %p",obj);
	
	if(obj)
	{
		EksParent *curLevel=haed_programinfo_get_current_level(HAED_GLOBAL_INFORMATION.firstProgram->program);
		EksParent *firstUnit=haed_unitlist_get_positions(curLevel)->firstChild;//curLevel->firstUnit->firstChild;
		haed_unitlist_remove(firstUnit,obj);
		
		gtk_widget_queue_draw(GLOBAL_LEVEL_EDITOR_DRAWING_AREA);
	}
}

/**
	The popupmenu which will appear if you click on a object in the field or at the sidebar.

	@param widget NO_FREE
		The parent widget
	@param event
		the event
	@param data NO_FREE
		???
	@return
		void
*/
///VARNING KÖRS ÄVEN I OBJECTSTRUCTURE!!!!
void haed_level_editor_active_object_popup_menu(GtkWidget *widget,GdkEvent *event, gpointer data)
{
	EksParent *thisObj=g_object_get_data(G_OBJECT(widget),"haed_object");
	int buttonOrOnField=1;
	
	
	if(thisObj==NULL)
	{
		thisObj=eks_parent_custom_get(HAED_GLOBAL_INFORMATION.levelEditorSelectedUnits,0);
		buttonOrOnField=0;
	}
	
	b_tm("object %s %d",thisObj->name,buttonOrOnField);

	GtkMenuListInner placedObject;
	GtkMenuListInner playerType;

	if(MAIN_ActiveObjectMenu!=NULL)
	{
		gtk_widget_destroy(MAIN_ActiveObjectMenu);
		MAIN_ActiveObjectMenu=NULL;
	}
	
	//the side widget is NOT selected
	if(!buttonOrOnField)
	{
		placedObject=(GtkMenuListInner){"Remove",haed_level_editor_active_object_remove_from_draw_area,HAED_GLOBAL_INFORMATION.levelEditorSelectedUnits};
	}
	else
	{
		placedObject=(GtkMenuListInner){NULL,NULL,NULL};
	}
	
	char *compstring=haed_object_get_string(thisObj,"mov");
	
	if(compstring && strcmp(compstring,"none")==0)
	{
		playerType=(GtkMenuListInner){"Select Player",NULL,NULL,(GtkMenuListInner[])
		{
			{"1",SelectPlayerActiveObjectButton,(void*)1},
			{"2",SelectPlayerActiveObjectButton,(void*)2},
			{"3",SelectPlayerActiveObjectButton,(void*)3},
			{"4",SelectPlayerActiveObjectButton,(void*)4}
		},4};
	}
	else
	{
		playerType=(GtkMenuListInner){NULL,NULL,NULL};
	}
	
	//general stuff
	GtkMenuListInner MAIN_ActiveObjectMenuList[]=
	{
		{"Movement",NULL,NULL,
		(GtkMenuListInner[]){
			{"Select Movement",SelectMovementActiveObjectButton,thisObj},
			{"Edit Movement",haed_object_modify_movement,thisObj},
			playerType,
		},3},
		{"View",NULL,NULL},
		{"Edit animations",haed_draw_active_object_frame_editor,eks_parent_custom_get(thisObj,HAED_OBJECT_BUFFHOLDER)},
		{"Object Preferences",haed_object_settings_window,thisObj}, //add edit name and icon here
		{"New Object",NULL,NULL},
		{"Resize",NULL,NULL},
		{"Align",NULL,NULL},
		placedObject
	};

	MAIN_ActiveObjectMenu=gtk_menu_new_from_list(MAIN_ActiveObjectMenuList,sizeof(MAIN_ActiveObjectMenuList)/sizeof(MAIN_ActiveObjectMenuList[0]));
	gtk_widget_show_all(MAIN_ActiveObjectMenu);
	
	CreatePopupMenu(MAIN_ActiveObjectMenu,event);
}
//==============================================

/**
	What happens when you click on the button to "draw" out an object in the main layot

	@param widget NO_FREE
		The button widget (the one you clicked on)
	@param data NO_FREE
		???
	@return
		void
*/
void SetCurrentLayoutObjectPointer(GtkWidget *widget,gpointer data)
{
	b_debug_message("set layout pointer");

	if(HAED_GLOBAL_INFORMATION.levelEditorSelectedSideBarWidget!=NULL && widget!=HAED_GLOBAL_INFORMATION.levelEditorSelectedSideBarWidget)
	{
		gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(HAED_GLOBAL_INFORMATION.levelEditorSelectedSideBarWidget),0);
		HAED_GLOBAL_INFORMATION.levelEditorSelectedSideBarWidget=NULL;
	}
	HAED_GLOBAL_INFORMATION.levelEditorSelectedSideBarWidget=widget;
	EksParent *temp=g_object_get_data(G_OBJECT(HAED_GLOBAL_INFORMATION.levelEditorSelectedSideBarWidget),"haed_object");
	
	b_debug_message("set pointer to:%s",temp->name);
}

/**
	Drawing events

	@param widget
		input widget
	@param cr
		cairo drawing 
	@param data
		user data
	
	@return boolean
		
*/
gboolean haed_level_editor_signal_draw(GtkWidget *widget, cairo_t *cr, gpointer data)
{
	int widgetWidth;
	int widgetHeight;

	EksParent *curLevel;

	if(data==NULL)
	{
		widgetWidth=gtk_widget_get_allocated_width(widget);
		widgetHeight=gtk_widget_get_allocated_height(widget);
		
		curLevel=haed_programinfo_get_current_level(HAED_GLOBAL_INFORMATION.firstProgram->program);
	}
	else
	{
		widgetWidth=SCREEN_WIDTH*1.3;
		widgetHeight=SCREEN_HEIGHT*1.3;
		
		cairo_scale(cr, (double)gtk_widget_get_allocated_width(widget)/widgetWidth, (double)gtk_widget_get_allocated_height(widget)/widgetHeight);
		
		curLevel=data;
	}
	
	MARGIN_SCREEN_WIDTH=widgetWidth-SCREEN_WIDTH>0?(widgetWidth-SCREEN_WIDTH)/2:MARGIN_SCREEN_WIDTH_MIN;
	MARGIN_SCREEN_HEIGHT=widgetHeight-SCREEN_HEIGHT>0?(widgetHeight-SCREEN_HEIGHT)/2:MARGIN_SCREEN_HEIGHT_MIN;
	
	cairo_rectangle(cr,0,0,widgetWidth,widgetHeight);
	
	int bRed,bGreen,bBlue;
			
	if(eks_parent_get_child_from_name(curLevel,"background-color"))
	{
		bRed=haed_get_int_from_pos(curLevel,"background-color",0);
		bGreen=haed_get_int_from_pos(curLevel,"background-color",1);
		bBlue=haed_get_int_from_pos(curLevel,"background-color",2);
	}
	else
	{
		bRed=255;
		bGreen=255;
		bBlue=255;
	}
	
	cairo_set_source_rgba (cr, 0.9, 0.9, 0.9, 1.0);
	cairo_fill (cr);
	//draw the area that will be shown
	cairo_rectangle(cr,MARGIN_SCREEN_WIDTH-PLACER_SCREEN_RANGE_X,MARGIN_SCREEN_HEIGHT-PLACER_SCREEN_RANGE_Y,SCREEN_WIDTH,SCREEN_HEIGHT);
	cairo_set_source_rgba (cr, (double)bRed/255, (double)bGreen/255, (double)bBlue/255, 1.0);
	cairo_fill (cr);
	
	//b_tm("GOT_HERE! %p %d",HAED_GLOBAL_INFORMATION.firstProgram->program,haed_trigghandler_count_objects(ACTIVE_OBJECT_S));
	
	EksParent *firstUnit=NULL;
	
	if(curLevel)
		firstUnit=haed_unitlist_get_positions(curLevel)->firstChild;//curLevel->firstUnit->firstChild;
	
	if(!firstUnit)
	{
		//b_error_message("No first child?");
		goto skip_draw;
	}
	
	EksParent *loopUnit=firstUnit;

	do
	{
		EksParent *unitObject=eks_parent_custom_get(loopUnit,0);
		
		gdk_cairo_set_source_pixbuf(cr,eks_parent_custom_get(unitObject,HAED_OBJECT_IMAGEBUFF),haed_unit_get_coord_x(loopUnit)-PLACER_SCREEN_RANGE_X+MARGIN_SCREEN_WIDTH,haed_unit_get_coord_y(loopUnit)-PLACER_SCREEN_RANGE_Y+MARGIN_SCREEN_HEIGHT);
	
		cairo_paint (cr);
		cairo_fill (cr);
	
		loopUnit=loopUnit->nextChild;
	}while(loopUnit!=firstUnit);

	skip_draw:
	
	if(GLOBAL_DRAG_BOX_POS[0]!=-1)
	{
		if(GLOBAL_DRAG_BOX_POS[2]-GLOBAL_DRAG_BOX_POS[0]<0 && GLOBAL_DRAG_BOX_POS[3]-GLOBAL_DRAG_BOX_POS[1]<0)
		{
			cairo_rectangle(cr,GLOBAL_DRAG_BOX_POS[2],GLOBAL_DRAG_BOX_POS[3],GLOBAL_DRAG_BOX_POS[0]-GLOBAL_DRAG_BOX_POS[2],GLOBAL_DRAG_BOX_POS[1]-GLOBAL_DRAG_BOX_POS[3]);
		}
		else if(GLOBAL_DRAG_BOX_POS[2]-GLOBAL_DRAG_BOX_POS[0]>0 && GLOBAL_DRAG_BOX_POS[3]-GLOBAL_DRAG_BOX_POS[1]>0)
		{
			cairo_rectangle(cr,GLOBAL_DRAG_BOX_POS[0],GLOBAL_DRAG_BOX_POS[1],GLOBAL_DRAG_BOX_POS[2]-GLOBAL_DRAG_BOX_POS[0],GLOBAL_DRAG_BOX_POS[3]-GLOBAL_DRAG_BOX_POS[1]);
		}
		else if(GLOBAL_DRAG_BOX_POS[2]-GLOBAL_DRAG_BOX_POS[0]<0 && GLOBAL_DRAG_BOX_POS[3]-GLOBAL_DRAG_BOX_POS[1]>0)
		{
			cairo_rectangle(cr,GLOBAL_DRAG_BOX_POS[2],GLOBAL_DRAG_BOX_POS[1],GLOBAL_DRAG_BOX_POS[0]-GLOBAL_DRAG_BOX_POS[2],GLOBAL_DRAG_BOX_POS[3]-GLOBAL_DRAG_BOX_POS[1]);
		}
		else if(GLOBAL_DRAG_BOX_POS[2]-GLOBAL_DRAG_BOX_POS[0]>0 && GLOBAL_DRAG_BOX_POS[3]-GLOBAL_DRAG_BOX_POS[1]<0)
		{
			cairo_rectangle(cr,GLOBAL_DRAG_BOX_POS[0],GLOBAL_DRAG_BOX_POS[3],GLOBAL_DRAG_BOX_POS[2]-GLOBAL_DRAG_BOX_POS[0],GLOBAL_DRAG_BOX_POS[1]-GLOBAL_DRAG_BOX_POS[3]);
		}
		
		//b_tm("HIT!");
		
		cairo_set_source_rgba (cr, 0, 0, 0,0.5);
		
		cairo_fill (cr);
	}
	
	return 1;
}

/**
	Event handling for the level editor

	@param widget
		input widget
	@param event
		input event (with all signals)
	@param data
		user data
	
	@return void
*/
void haed_level_editor_signal_event(GtkWidget *widget,GdkEvent *event,gpointer data)
{
	//b_tm("event");
	EksParent *curLevel=haed_programinfo_get_current_level(HAED_GLOBAL_INFORMATION.firstProgram->program);
	EksParent *positions=haed_unitlist_get_positions(curLevel);
	EksParent *firstUnit=positions->firstChild;

	if(event->button.type==GDK_BUTTON_PRESS)
	{
		if(firstUnit)
		{
			EksParent *loopUnit=firstUnit;

			do
			{
				int currX=haed_unit_get_coord_x(loopUnit);
				int currY=haed_unit_get_coord_y(loopUnit);
				
				b_tm("TESTEST: mx=%g my=%g",event->motion.x,event->motion.y);
				
				GdkPixbuf *objimagebuff=eks_parent_custom_get((EksParent*)eks_parent_custom_get(loopUnit,0),HAED_OBJECT_IMAGEBUFF);
				
				if((double)(currX-PLACER_SCREEN_RANGE_X+MARGIN_SCREEN_WIDTH)<=event->motion.x && (double)(currX-PLACER_SCREEN_RANGE_X+MARGIN_SCREEN_WIDTH+gdk_pixbuf_get_width(objimagebuff))>=event->motion.x && 
					(double)(currY-PLACER_SCREEN_RANGE_Y+MARGIN_SCREEN_HEIGHT)<=event->motion.y && (double)(currY-PLACER_SCREEN_RANGE_Y+MARGIN_SCREEN_HEIGHT+gdk_pixbuf_get_height(objimagebuff))>=event->motion.y)
				{
					gtk_widget_grab_focus(widget);
					
					//temp solution, should support multiple objects
					HAED_GLOBAL_INFORMATION.levelEditorSelectedUnits=loopUnit;
				
					if(event->button.button==3)
					{
						haed_level_editor_active_object_popup_menu(NULL,event,NULL);
						MOV_OBJECT[0]=-1;
						GLOBAL_DRAG_BOX_POS[0]=-1;
						return;
					}
					else if(event->button.button==1)
					{
						MOV_OBJECT[0]=event->motion.x-currX;
						MOV_OBJECT[1]=event->motion.y-currY;
					}
				}
		
				loopUnit=loopUnit->nextChild;
			}while(loopUnit!=firstUnit);
		}
	}
	
	
	if(HAED_GLOBAL_INFORMATION.levelEditorSelectedUnits && event->type==GDK_KEY_PRESS)
	{
		int px=0,py=0;
		
		if(event->key.keyval==GDK_KEY_Up)
			py=-1;
		if(event->key.keyval==GDK_KEY_Down)
			py=1;
		if(event->key.keyval==GDK_KEY_Left)
			px=-1;
		if(event->key.keyval==GDK_KEY_Right)
			px=1;
		
		EksParent *currUnit=HAED_GLOBAL_INFORMATION.levelEditorSelectedUnits;
		
		EksParent *xParent=eks_parent_get_child_from_type(currUnit,0,EKS_PARENT_TYPE_VALUE);
		EksParent *yParent=eks_parent_get_child_from_type(currUnit,1,EKS_PARENT_TYPE_VALUE);
		
		xParent->iname+=px;
		yParent->iname+=py;
		
		gtk_widget_queue_draw(GLOBAL_LEVEL_EDITOR_DRAWING_AREA);
	}
	
	if(event->button.type==GDK_MOTION_NOTIFY)
	{
		if(MOV_OBJECT[0]!=-1)
		{
			EksParent *currUnit=HAED_GLOBAL_INFORMATION.levelEditorSelectedUnits;
			
			EksParent *xParent=eks_parent_get_child_from_type(currUnit,0,EKS_PARENT_TYPE_VALUE);
			EksParent *yParent=eks_parent_get_child_from_type(currUnit,1,EKS_PARENT_TYPE_VALUE);
			
			xParent->iname=event->motion.x-MOV_OBJECT[0];
			yParent->iname=event->motion.y-MOV_OBJECT[1];
			//MOV_OBJECT[0]=-1;
			GLOBAL_DRAG_BOX_POS[0]=-1;
		}
		else
		{
			GLOBAL_DRAG_BOX_POS[2]=event->motion.x;
			GLOBAL_DRAG_BOX_POS[3]=event->motion.y;
		}
		
		gtk_widget_queue_draw(GLOBAL_LEVEL_EDITOR_DRAWING_AREA);
	}
	
	if(event->button.type==GDK_BUTTON_RELEASE)
	{
		GLOBAL_DRAG_BOX_POS[0]=-1;
		MOV_OBJECT[0]=-1;
		gtk_widget_queue_draw(GLOBAL_LEVEL_EDITOR_DRAWING_AREA);
	}
	
	if(event->button.type==GDK_BUTTON_PRESS)
	{
		//gtk_widget_hide(GLOBAL_DRAG_BOX_WIDGET);
		if(GLOBAL_DRAG_BOX_POS[0]==-1 && MOV_OBJECT[0]==-1)
		{
			GLOBAL_DRAG_BOX_POS[0]=event->motion.x;
			GLOBAL_DRAG_BOX_POS[1]=event->motion.y;
		}
		
		//for the output of objects
		if(HAED_GLOBAL_INFORMATION.levelEditorSelectedSideBarWidget!=NULL && gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(HAED_GLOBAL_INFORMATION.levelEditorSelectedSideBarWidget)))
		{
			
			if(HAED_GLOBAL_INFORMATION.levelEditorSelectedSideBarWidget)
				haed_unitlist_add(positions,(EksParent*)g_object_get_data(G_OBJECT(HAED_GLOBAL_INFORMATION.levelEditorSelectedSideBarWidget),"haed_object"),(int)event->motion.x-MARGIN_SCREEN_WIDTH+PLACER_SCREEN_RANGE_X,(int)event->motion.y-MARGIN_SCREEN_HEIGHT+PLACER_SCREEN_RANGE_Y);
			
			if(event->button.button==1)
			{
				gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(HAED_GLOBAL_INFORMATION.levelEditorSelectedSideBarWidget),0);
				HAED_GLOBAL_INFORMATION.levelEditorSelectedSideBarWidget=NULL;
			}
			
			gtk_widget_queue_draw(GLOBAL_LEVEL_EDITOR_DRAWING_AREA);
		}
	}
	//unfocus?
	//gtk_widget_grab_focus(MAIN_WINDOW);
}

void haed_update_event_editor_placer(GtkRange *range,gpointer  user_data)
{
	gtk_widget_queue_draw(GLOBAL_LEVEL_EDITOR_DRAWING_AREA);
	
	PLACER_SCREEN_RANGE_X=((gtk_range_get_value(GTK_RANGE(MAIN_LevelEditor_Scrollbars[1]))*abs(MARGIN_SCREEN_WIDTH*2+SCREEN_WIDTH-gtk_widget_get_allocated_width(GLOBAL_LEVEL_EDITOR_DRAWING_AREA)))/100);
	PLACER_SCREEN_RANGE_Y=((gtk_range_get_value(GTK_RANGE(MAIN_LevelEditor_Scrollbars[0]))*abs(MARGIN_SCREEN_HEIGHT*2+SCREEN_HEIGHT-gtk_widget_get_allocated_height(GLOBAL_LEVEL_EDITOR_DRAWING_AREA)))/100);
	
	//printf("%f %f\n",PLACER_SCREEN_RANGE_X,PLACER_SCREEN_RANGE_Y);
}
